//+------------------------------------------------------------------+
//|                                                 SoftFractals.mq4 |
//|                                                    .. |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright " .."
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Green
//---- buffers
double Buffer1[],
       Buffer2[];
//---- parameters
extern bool StrongLeft=false, //   
            StrongRight=false,//   
            Repeat=true,      //  / 
            Signals=false;    //  ,   
bool NotFirstStart,
     Ban1, Ban2;
extern int BarsBefore=2,      //    
           BarsAfter=2,       //    
           Width=1,           //  
           Arrow=163;         //   /
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0, DRAW_ARROW, EMPTY, Width);
   SetIndexArrow(0, Arrow);
   SetIndexBuffer(0, Buffer1);
   SetIndexEmptyValue(0, 0.0);
   SetIndexStyle(1, DRAW_ARROW, EMPTY, Width);
   SetIndexArrow(1, Arrow);
   SetIndexBuffer(1, Buffer2);
   SetIndexEmptyValue(1, 0.0);
//---- name for DataWindow and indicator subwindow label
   if( Signals )
     {
      IndicatorShortName("Signals");
      SetIndexLabel(0, "Sell");
      SetIndexLabel(1, "Buy");
     }
   else
     {
      IndicatorShortName("Fractals");
      SetIndexLabel(0, "High");
      SetIndexLabel(1, "Low");
     }
   NotFirstStart=false;
   Ban1=false;
   Ban2=false;
   if( BarsBefore<1 ) BarsBefore=1;
   if( BarsAfter<1 ) BarsAfter=1;
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   if( !NewBar() ) return(0);
   double R, C[]; 
   int dim=ArrayResize(C, BarsBefore+1+BarsAfter),
       i, j;
   if( NotFirstStart ) i=BarsAfter+1; else i=Bars-BarsBefore-1;
//----  
   while( i > BarsAfter )
     {
      R=0;
      j=0;
      while ( j < dim ) { C[j]=High[j+i-BarsAfter]; j++; }
      if( C[BarsAfter+1] < C[BarsAfter] && C[BarsAfter] >= C[BarsAfter-1] )
        {
         R=C[BarsAfter];                        //  
         j=1;
         while ( j < dim )
           {
            if( ( j < BarsAfter && C[j-1] > C[j] && StrongRight )
             || ( j < BarsAfter && C[j-1] > R && !StrongRight )
             || ( j > BarsAfter && C[j] >= C[j-1] && StrongLeft )
             || ( j > BarsAfter && C[j] >= R && !StrongLeft ) )
              { R=0; break; }                   //  
            j++;
           }
        }
      if( R >= Point )
        {
         if( Signals )
           {
            j=i-BarsAfter-1;                    //  
            R=Open[j];                          //  
           }
         else j=i;                              //  
         if( !Ban1 )
           {   //         
            Buffer1[j]=R;
            if( !Repeat ) { Ban1=true; Ban2=false; }
           }
        }
      R=0;
      j=0;
      while ( j < dim ) { C[j]=Low[j+i-BarsAfter]; j++; }
      if( C[BarsAfter+1] > C[BarsAfter] && C[BarsAfter] <= C[BarsAfter-1] )
        {
         R=C[BarsAfter];                        //  
         j=1;
         while ( j < dim )
           {
            if( ( j < BarsAfter && C[j-1] < C[j] && StrongRight )
             || ( j < BarsAfter && C[j-1] < R && !StrongRight )
             || ( j > BarsAfter && C[j] <= C[j-1] && StrongLeft )
             || ( j > BarsAfter && C[j] <= R && !StrongLeft ) )
              { R=0; break; }                   //  
            j++;
           }
        }
      if( R >= Point )
        {
         if( Signals )
           {
            j=i-BarsAfter-1;                    //  
            R=Open[j];                          //  
           }
         else j=i;                              //  
         if( !Ban2 )
           {   //         
            Buffer2[j]=R;
            if( !Repeat ) { Ban1=false; Ban2=true; }
           }
        }
      i--;
     }
   WindowRedraw();                              //  .
   if( !NotFirstStart ) NotFirstStart=true;
//----
   return(0);
  }
//+------------------------------------------------------------------+
//|   
//+------------------------------------------------------------------+
bool NewBar() 
  {
//----
   static datetime NewTime;                     //   
   bool NewBar=false;                           //   
   if( NewTime!=Time[0] )
     {
      NewTime=Time[0];                          //   
      NewBar=true;                              //   
     }
//----
   return(NewBar);
  }
//+------------------------------------------------------------------+